#line 1 "C:/Users/stefan.popovic/Downloads/pwm_driver_avr.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 54 "C:/Users/stefan.popovic/Downloads/pwm_driver_avr.c"
 sbit LCD_RS at PORTA2_bit;
 sbit LCD_EN at PORTD6_bit;
 sbit LCD_D4 at PORTC4_bit;
 sbit LCD_D5 at PORTC5_bit;
 sbit LCD_D6 at PORTC6_bit;
 sbit LCD_D7 at PORTC7_bit;

 sbit LCD_RS_Direction at DDA2_bit;
 sbit LCD_EN_Direction at DDD6_bit;
 sbit LCD_D4_Direction at DDC4_bit;
 sbit LCD_D5_Direction at DDC5_bit;
 sbit LCD_D6_Direction at DDC6_bit;
 sbit LCD_D7_Direction at DDC7_bit;


 uint16_t current_duty;
 uint16_t adc_rd;
 char txt1[] = "PWM driver click";
 char txt2[] = "PWM Duty";
 char txt3[] = "%";
 char txt[5];

 void MCU_Init()
 {
 ADC_Init();
 PWM16bit_Init(_PWM16_PHASE_CORRECT_MODE_8BIT, _PWM16_PRESCALER_16bit_8, _PWM16_NON_INVERTED, 255, 1);
 PWM16bit_Start(_TIMER1);
 PWM16bit_Change_Duty(current_duty, _TIMER1_CH_B);

 Delay_ms(100);

 current_duty = 0;
 }

 void Lcd_Display()
 {
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 1, txt1);
 Lcd_Out(2, 1, txt2);
 Lcd_Out(2, 16, txt3);
 }

 void main()
 {
 MCU_Init();
 Lcd_Init();
 Lcd_Display();
 DDA6_bit = 0;
 DDD4_bit = 1;

 while( 1 )
 {
 uint8_t cur_duty_byte;


 adc_rd = ADC_Read(6) & 0x0000FFFF;
 current_duty = adc_rd / 4 ;
 cur_duty_byte =  ((unsigned *)&current_duty)[0] ;
 cur_duty_byte = cur_duty_byte * 0.39;
 PWM16bit_Change_Duty(cur_duty_byte, _TIMER1_CH_B);
 ByteToStr(cur_duty_byte, txt);
 Lcd_Out(2, 11, txt);
 Delay_ms( 20 );
 }
 }
